//+------------------------------------------------------------------+
//|                                                     			 eFore |
//|     																						 |
//|       				 |
//|					 																						 |
//|  7 , 2011  | http://www.mql5.com/ru/articles/250					 |
//|  :  | https://login.mql5.com/ru/users/yosuf				 |
//| 																																 |
//|  programming & support - Alex Sergeev (profy.mql@gmail.com) 		 |
//|	 23.02.2011                                                      |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Yosuf,  Alex Sergeev"
#property link      "profy.mql@gmail.com"
#include <stderror.mqh>
#include <stdlib.mqh>

extern int HourStart=0; //     -  23:00  9:00
extern int HourEnd=24;
extern int MaxOrder=1000; //    
extern double Lot=0.1; //  ,  =0,   Risk
extern double Risk=0; //  -  %  .
extern string inf1="";
extern bool bRevers=false; //  
extern string inf2="";
extern bool bCloseByTrend=true; //  ,      +/-minTrend.
extern int SL=1000; // , 0- 
extern int TP=0; // , 0-
extern string inf3="";
extern string FName="_Forecast_v12";
extern int N=92; //   
extern int Future=1; //    (     )
extern int iN=1; // =0 -    , =1-  
extern double minDRP3P=0; //      3()  
extern double minTrend=1; //    1+2+3
extern int nBar=1; //        ( )
extern int Magic=123; //    
extern int Slip=0; //     

//  
string gsID, sID; // ID    
bool bTesting; //     
//   
double FreezLvl, StopLvl, Spread, Pnt, _Point, _Digits, _Bid, _Ask, LotStep, LotSize, MaxLot, MinLot, TickSize, TickVal, ProfitCalcMode;
string inf, zn="\n        ", zzn="     ";

//------------------------------------------------------------------ init
int init() { bTesting=true; return(0); }
//------------------------------------------------------------------ deinit
int deinit() 
{ 
	if (IsTesting() || IsOptimization()) GlobalVariablesDeleteAll(gsID); 
	return(0); 
}
//------------------------------------------------------------------ start
int start()
{
	string smb=Symbol();
	int tf=Period();
	gsID=smb+IsDemo()+IsTesting()+IsOptimization()+"."+Magic;
	inf="";
	INF(TTS(TimeCurrent()), true);
	main(Magic, smb, tf);
	Comment(inf);
}
//------------------------------------------------------------------ main
int main(int SysID, string smb, int tf)
{
	if (!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected()) return; //   ,  
	sID=gsID+"."+SysID+".";

	RefreshParam(smb); 
	
	if (bTesting && (IsTesting() || IsOptimization())) { GlobalVariablesDeleteAll(sID); bTesting=false; }
	
	OpenPos(SysID, smb, tf);
	ClosePos(SysID, smb, tf);
}
//------------------------------------------------------------------ OpenPos
void OpenPos(int SysID, string smb, int tf)
{
	INF("+OpenPos ", true); 
	if (CountOrders(-1, SysID, smb)>=MaxOrder) { INF("  ="+MaxOrder); return; }
	if (!CheckTime()) { INF("  "); return; }
	if (GlobalVariableGet(sID+"Time")>=iTime(smb, tf, 0)) { INF("  "); return; }
	int dir=CheckOpenSignal(smb, tf); if (dir<0) { INF("  "); return; }
	INF("= "+OTS(dir)); 
	double apr=APR(dir), op=NPR(dir);
	double lot=NL(IIF(Lot>0, Lot, AccountBalance()*Risk/1000));
	int ticket=OrderSend(smb, dir, lot, op, Slip, 0, 0, "", SysID);
	if (ticket<=0) ErrorHandle(GetLastError(), -1, SysID, "-OpenPos "+OTS(dir)+" op="+DTS(op)+" lot="+DTS(lot, 2));
	else
	{
		Print("+OpenPos "+OTS(dir)+"#"+ticket+" op="+DTS(op)+" lot="+DTS(lot, 2));
		GlobalVariableSet(sID+"Time", iTime(smb, tf, 0));
		while (true)
		{
			RefreshParam(smb);
			apr=APR(dir);
			double tp=NTP(dir, op, apr, SL, StopLvl);
			double sl=NSL(dir, op, apr, TP, StopLvl);
			if (OrderModify(ticket, op, sl, tp, 0)) break;
			ErrorHandle(GetLastError(), -1, SysID, "-SetStops "+OTS(dir)+" op="+DTS(op)+" sl="+DTS(sl)+" tp="+DTS(tp));
		}
	}
}
//------------------------------------------------------------------ ClosePos
void ClosePos(int SysID, string smb, int tf)
{
	if (!bCloseByTrend) return;
	if (CountOrders(-1, SysID, smb)<=0) return;
	INF("+ClosePos", true);
	int dir=CheckCloseSignal(smb, tf);
	if (CloseOrders(dir, SysID, smb)>0) Print("      "+OTS(dir));
}
//---------------------------------------------------------------   CheckTime
bool CheckTime()
{
	datetime dt=TimeCurrent();
	datetime dt1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+HourStart+":00"); //     -  23:00  9:00
	datetime dt2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+HourEnd+":00"); //     -  23:00  9:00
	if (dt1<dt2) if (dt>=dt1 && dt<dt2) return(true);
	if (dt1>dt2) if (dt>=dt1 || dt<dt2) return(true);
	return(false);
}
//---------------------------------------------------------------   CheckOpenSignal
int CheckOpenSignal(string smb, int tf)
{
	int dir=-1;
	double buy=iCustom(smb, tf, FName, N, Future, iN, minDRP3P, minTrend, nBar, 3, 0);
	double sell=iCustom(smb, tf, FName, N, Future, iN, minDRP3P, minTrend, nBar, 4, 0);
	if (buy>0 && buy!=EMPTY_VALUE) dir=OP_BUY; if (sell>0 && sell!=EMPTY_VALUE) dir=OP_SELL;
	if (bRevers) dir=ADIR(dir);
	INF("buy="+buy+"  sell="+sell+"  dir="+OTS(dir));
	return(dir);
}
//---------------------------------------------------------------   CheckCloseSignal
int CheckCloseSignal(string smb, int tf)
{
	int dir=ADIR(CheckOpenSignal(smb, tf));
	return(dir);
}
//---------------------------------------------------------------   IsDir
bool IsDir(int dir, int type)
{
	if (dir<0) return(true);
	if (dir>=0 && dir<6 && type!=dir) return(false);
	return(true);
}
//---------------------------------------------------------------   CountOrders
int CountOrders(int dir, int SysID, string smb)
{
	int total=OrdersTotal(), c=0; if (total<=0) return (0);
	for(int i=0; i<total; i++) 
	{ 
		if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { ErrorHandle(GetLastError(), -1, SysID, "CountOrders - SelectOrder. i="+i+"  total="+total);  return(-1); }		
		if (!IsDir(dir, OrderType()) || OrderMagicNumber()!=SysID || (OrderSymbol()!=smb&&smb!="")) continue;
		c++;
	}
	return(c);
}
//---------------------------------------------------------------   CloseOrders
int CloseOrders(int dir, int SysID, string smb)
{
	int i, total = OrdersTotal();	if (total<=0) return(0);
	int ticket[1000], nt=0; double op;

	nt=0;
	for (i=0; i<total; i++)	
	{	
		if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { ErrorHandle(GetLastError(), ticket[i], SysID, "OrderClose - Select "+i);  return(-1); }
		if (!IsDir(dir, OrderType()) || OrderMagicNumber()!=SysID || (OrderSymbol()!=smb&&smb!="")) continue;
		ticket[nt]=OrderTicket(); nt++;
	}
	for (i=0; i<nt; i++)
	{	
		if (!OrderSelect(ticket[i], SELECT_BY_TICKET)) { ErrorHandle(GetLastError(), ticket[i], SysID, "OrderClose - Select#"+ticket[i]+"  nt="+nt+"  i="+i);  return(-1); }
		dir=OrderType(); RefreshParam(OrderSymbol());
		if (dir==OP_BUY) op=_Bid; else if (dir==OP_SELL) op=_Ask;
		if (dir==OP_BUY || dir==OP_SELL) if (!OrderClose(ticket[i], OrderLots(), op, Slip)) { ErrorHandle(GetLastError(), ticket[i], SysID, "OrderClose#="+ticket[i]+"  nt="+nt+"  i="+i); return(-1); }
		if (dir==OP_BUYLIMIT || dir==OP_SELLLIMIT || dir==OP_BUYSTOP || dir==OP_SELLSTOP)
			if (!OrderDelete(ticket[i])) { ErrorHandle(GetLastError(), ticket[i], SysID, "OrderDelete#="+OrderTicket()); return(-1); }
	}
	return(nt);
}
//---------------------------------------------------------------   RefreshParam
void RefreshParam(string smb)
{
	RefreshRates();
	_Digits=MarketInfo(smb, MODE_DIGITS);
	Pnt=1; if (_Digits==5 || _Digits==3) Pnt=10;
	_Point=MarketInfo(smb, MODE_POINT);
	FreezLvl=MarketInfo(smb, MODE_FREEZELEVEL)*_Point;
	StopLvl=MarketInfo(smb, MODE_STOPLEVEL)*_Point;
	Spread=MarketInfo(smb, MODE_SPREAD)*_Point;
 	LotSize=MarketInfo(smb, MODE_LOTSIZE); 
 	LotStep=MarketInfo(smb, MODE_LOTSTEP);
 	MinLot=MarketInfo(smb, MODE_MINLOT);
 	MaxLot=MarketInfo(smb, MODE_MAXLOT);
 	TickVal=MarketInfo(smb, MODE_TICKVALUE); if (TickVal==0) TickVal=10.0/Pnt;
	TickSize=MarketInfo(smb, MODE_TICKSIZE); if (TickSize==0) TickSize=1;
 	ProfitCalcMode=MarketInfo(smb, MODE_PROFITCALCMODE);
 	if (_Point==0 && _Digits!=0) _Point=1/_Digits;
	_Bid=NP(MarketInfo(smb, MODE_BID));
	_Ask=NP(MarketInfo(smb, MODE_ASK));
}
//---------------------------------------------------------------   ErrorHandle
void ErrorHandle(int err, int OrderID, int SysID, string str)
{
	Print("("+err+"): "+ErrorDescription(err)+"-Magic: "+SysID+" #"+OrderID+" | "+str); 
	switch (err)
	{
		case ERR_SERVER_BUSY: //4    
		case ERR_NO_CONNECTION: //6      
		case ERR_TOO_FREQUENT_REQUESTS: //8    
		case ERR_BROKER_BUSY: //137   
		case ERR_TOO_MANY_REQUESTS: //141    
		case ERR_TRADE_CONTEXT_BUSY: //146    
			Sleep(2000); //  2 
			break;
		
		case ERR_PRICE_CHANGED: //135   
		case ERR_REQUOTE: //138   
			RefreshRates(); //   
			break;
	}
}
//---------------------------------------------------------------   NPR
double NPR(int dir) 
{ 
	if (dir==OP_BUY || dir==OP_BUYSTOP || dir==OP_BUYLIMIT) return(_Ask);
	if (dir==OP_SELL || dir==OP_SELLSTOP || dir==OP_SELLLIMIT) return(_Bid);
}
//---------------------------------------------------------------   APR
double APR(int dir) 
{ 
	if (dir==OP_BUY || dir==OP_BUYSTOP || dir==OP_BUYLIMIT) return(_Bid);
	if (dir==OP_SELL || dir==OP_SELLSTOP || dir==OP_SELLLIMIT) return(_Ask);
}
//---------------------------------------------------------------   NSL
double NSL(int dir, double op, double pr, int SL, double stop)
{
	if (SL==0) return(NP(0));
	if (dir==OP_BUY || dir==OP_BUYSTOP || dir==OP_BUYLIMIT) return(NP(MathMin(op-SL*Pnt*_Point, pr-stop)));
	if (dir==OP_SELL || dir==OP_SELLSTOP || dir==OP_SELLLIMIT) return(NP(MathMax(op+SL*Pnt*_Point, pr+stop)));
}
//---------------------------------------------------------------   ND
double ND(double d, int n=-1) {  if (n<0) return(NormalizeDouble(d, _Digits)); return(NormalizeDouble(d, n)); }
//---------------------------------------------------------------   NP
double NP(double d) { return (ND(MathRound(d/TickSize)*TickSize)); }
//---------------------------------------------------------------   NL
double NL(double lot) 
{
	int k=0;
	double ll=lot, ls=LotStep;
	if (ls<=0.001) k=3; else if (ls<=0.01) k=2; else if (ls<=0.1) k=1;
	ll=ND(MathMin(MaxLot, MathMax(MinLot, ll)), k);
	return(ll);
}
//---------------------------------------------------------------   DTS
string DTS(double d, int n=-1) { if (d==EMPTY_VALUE) return("<>"); if (n<0) return(DoubleToStr(d, _Digits)); else return(DoubleToStr(d, n)); }
//---------------------------------------------------------------   TTS
string TTS(datetime time) { return (TimeToStr(time, TIME_DATE|TIME_SECONDS)); }
//---------------------------------------------------------------   OTS
string OTS(int n)
{
	int p[6]={OP_BUY, OP_SELL, OP_BUYLIMIT, OP_SELLLIMIT, OP_BUYSTOP, OP_SELLSTOP};
	string sp[6]={"BUY", "SELL", "BUYLIMIT", "SELLLIMIT", "BUYSTOP", "SELLSTOP"};
	for (int i=0; i<6; i++) if (p[i]==n) return(sp[i]);
	return("--");
}
//---------------------------------------------------------------   INF
void INF(string st, bool ini=false) { if (ini) inf=inf+zn+st; else inf=inf+zn+zzn+st; }
//---------------------------------------------------------------   IIF
double IIF(bool cond, double a1, double a2) { if (cond) return (a1); else return(a2); }
//---------------------------------------------------------------   ADIR
int ADIR(int dir)
{
	int p[6]={OP_BUY, OP_SELL, OP_BUYLIMIT, OP_SELLLIMIT, OP_BUYSTOP, OP_SELLSTOP};
	int a[6]={OP_SELL, OP_BUY, OP_SELLLIMIT, OP_BUYLIMIT, OP_SELLSTOP, OP_BUYSTOP};
	for (int i=0; i<6; i++) if (p[i]==dir) return(a[i]);
	return(dir);
}
//---------------------------------------------------------------   NTP
double NTP(int dir, double op, double pr, int TP, double stop)
{
	if (TP==0) return(NP(0));
	if (dir==OP_BUY || dir==OP_BUYSTOP || dir==OP_BUYLIMIT) return(NP(MathMax(op+TP*Pnt*_Point, pr+stop)));
	if (dir==OP_SELL || dir==OP_SELLSTOP || dir==OP_SELLLIMIT) return(NP(MathMin(op-TP*Pnt*_Point, pr-stop)));
}

